# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class TreatmentParameters(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, pressure: float=None, frequency: float=None, flow: float=None, lung_tidal_vol: float=None, lung_inspiratory_reserve_vol: float=None, lung_expiratory_reserve_vol: float=None, lung_residual_vol: float=None):  # noqa: E501
        """TreatmentParameters - a model defined in Swagger

        :param pressure: The pressure of this TreatmentParameters.  # noqa: E501
        :type pressure: float
        :param frequency: The frequency of this TreatmentParameters.  # noqa: E501
        :type frequency: float
        :param flow: The flow of this TreatmentParameters.  # noqa: E501
        :type flow: float
        :param lung_tidal_vol: The lung_tidal_vol of this TreatmentParameters.  # noqa: E501
        :type lung_tidal_vol: float
        :param lung_inspiratory_reserve_vol: The lung_inspiratory_reserve_vol of this TreatmentParameters.  # noqa: E501
        :type lung_inspiratory_reserve_vol: float
        :param lung_expiratory_reserve_vol: The lung_expiratory_reserve_vol of this TreatmentParameters.  # noqa: E501
        :type lung_expiratory_reserve_vol: float
        :param lung_residual_vol: The lung_residual_vol of this TreatmentParameters.  # noqa: E501
        :type lung_residual_vol: float
        """
        self.swagger_types = {
            'pressure': float,
            'frequency': float,
            'flow': float,
            'lung_tidal_vol': float,
            'lung_inspiratory_reserve_vol': float,
            'lung_expiratory_reserve_vol': float,
            'lung_residual_vol': float
        }

        self.attribute_map = {
            'pressure': 'pressure',
            'frequency': 'frequency',
            'flow': 'flow',
            'lung_tidal_vol': 'lung-tidal-vol',
            'lung_inspiratory_reserve_vol': 'lung-inspiratory-reserve-vol',
            'lung_expiratory_reserve_vol': 'lung-expiratory-reserve-vol',
            'lung_residual_vol': 'lung-residual-vol'
        }
        self._pressure = pressure
        self._frequency = frequency
        self._flow = flow
        self._lung_tidal_vol = lung_tidal_vol
        self._lung_inspiratory_reserve_vol = lung_inspiratory_reserve_vol
        self._lung_expiratory_reserve_vol = lung_expiratory_reserve_vol
        self._lung_residual_vol = lung_residual_vol

    @classmethod
    def from_dict(cls, dikt) -> 'TreatmentParameters':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The treatmentParameters of this TreatmentParameters.  # noqa: E501
        :rtype: TreatmentParameters
        """
        return util.deserialize_model(dikt, cls)

    @property
    def pressure(self) -> float:
        """Gets the pressure of this TreatmentParameters.

        required lung pressure in mbar  # noqa: E501

        :return: The pressure of this TreatmentParameters.
        :rtype: float
        """
        return self._pressure

    @pressure.setter
    def pressure(self, pressure: float):
        """Sets the pressure of this TreatmentParameters.

        required lung pressure in mbar  # noqa: E501

        :param pressure: The pressure of this TreatmentParameters.
        :type pressure: float
        """

        self._pressure = pressure

    @property
    def frequency(self) -> float:
        """Gets the frequency of this TreatmentParameters.

        breath cycles per second  # noqa: E501

        :return: The frequency of this TreatmentParameters.
        :rtype: float
        """
        return self._frequency

    @frequency.setter
    def frequency(self, frequency: float):
        """Sets the frequency of this TreatmentParameters.

        breath cycles per second  # noqa: E501

        :param frequency: The frequency of this TreatmentParameters.
        :type frequency: float
        """

        self._frequency = frequency

    @property
    def flow(self) -> float:
        """Gets the flow of this TreatmentParameters.

        moved gas volume per breath cycle in ml  # noqa: E501

        :return: The flow of this TreatmentParameters.
        :rtype: float
        """
        return self._flow

    @flow.setter
    def flow(self, flow: float):
        """Sets the flow of this TreatmentParameters.

        moved gas volume per breath cycle in ml  # noqa: E501

        :param flow: The flow of this TreatmentParameters.
        :type flow: float
        """

        self._flow = flow

    @property
    def lung_tidal_vol(self) -> float:
        """Gets the lung_tidal_vol of this TreatmentParameters.

        tidal volume (TV) of lung in ml  # noqa: E501

        :return: The lung_tidal_vol of this TreatmentParameters.
        :rtype: float
        """
        return self._lung_tidal_vol

    @lung_tidal_vol.setter
    def lung_tidal_vol(self, lung_tidal_vol: float):
        """Sets the lung_tidal_vol of this TreatmentParameters.

        tidal volume (TV) of lung in ml  # noqa: E501

        :param lung_tidal_vol: The lung_tidal_vol of this TreatmentParameters.
        :type lung_tidal_vol: float
        """

        self._lung_tidal_vol = lung_tidal_vol

    @property
    def lung_inspiratory_reserve_vol(self) -> float:
        """Gets the lung_inspiratory_reserve_vol of this TreatmentParameters.

        inspiratory reserve volume (IRV) of lung in ml  # noqa: E501

        :return: The lung_inspiratory_reserve_vol of this TreatmentParameters.
        :rtype: float
        """
        return self._lung_inspiratory_reserve_vol

    @lung_inspiratory_reserve_vol.setter
    def lung_inspiratory_reserve_vol(self, lung_inspiratory_reserve_vol: float):
        """Sets the lung_inspiratory_reserve_vol of this TreatmentParameters.

        inspiratory reserve volume (IRV) of lung in ml  # noqa: E501

        :param lung_inspiratory_reserve_vol: The lung_inspiratory_reserve_vol of this TreatmentParameters.
        :type lung_inspiratory_reserve_vol: float
        """

        self._lung_inspiratory_reserve_vol = lung_inspiratory_reserve_vol

    @property
    def lung_expiratory_reserve_vol(self) -> float:
        """Gets the lung_expiratory_reserve_vol of this TreatmentParameters.

        expiratory reserve volume (ERV) of lung in ml  # noqa: E501

        :return: The lung_expiratory_reserve_vol of this TreatmentParameters.
        :rtype: float
        """
        return self._lung_expiratory_reserve_vol

    @lung_expiratory_reserve_vol.setter
    def lung_expiratory_reserve_vol(self, lung_expiratory_reserve_vol: float):
        """Sets the lung_expiratory_reserve_vol of this TreatmentParameters.

        expiratory reserve volume (ERV) of lung in ml  # noqa: E501

        :param lung_expiratory_reserve_vol: The lung_expiratory_reserve_vol of this TreatmentParameters.
        :type lung_expiratory_reserve_vol: float
        """

        self._lung_expiratory_reserve_vol = lung_expiratory_reserve_vol

    @property
    def lung_residual_vol(self) -> float:
        """Gets the lung_residual_vol of this TreatmentParameters.

        residual volume (RV) of lung in ml  # noqa: E501

        :return: The lung_residual_vol of this TreatmentParameters.
        :rtype: float
        """
        return self._lung_residual_vol

    @lung_residual_vol.setter
    def lung_residual_vol(self, lung_residual_vol: float):
        """Sets the lung_residual_vol of this TreatmentParameters.

        residual volume (RV) of lung in ml  # noqa: E501

        :param lung_residual_vol: The lung_residual_vol of this TreatmentParameters.
        :type lung_residual_vol: float
        """

        self._lung_residual_vol = lung_residual_vol
